明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2357|回复: 2

[求助]使用CAD的API怎样填充一个圆?

[复制链接]
发表于 2007-10-22 17:34:00 | 显示全部楼层 |阅读模式

怎样填充一个圆?

使用下面代码先创建一个圆然后填充,为什么运行到fillHatch.EvaluateHatch(false); 行时出现错误:“eAmbiguousOutput”?各位高手帮忙解决一下,先谢谢了。
            try
            {
                Database db = HostApplicationServices.WorkingDatabase;// 获得当前工作空间的数据库
                using(Transaction trans = db.TransactionManager.StartTransaction())// begin the transaction
                {
                    BlockTable bt = trans.GetObject(db.BlockTableId, OpenMode.ForWrite) as BlockTable;//获得块表
                    BlockTableRecord btr = bt[BlockTableRecord.ModelSpace].GetObject(OpenMode.ForWrite) as BlockTableRecord;//获得模型空间的块表记录
                    oint3d Point = Point3d(10, 200, 200);
                    Circle pointCircle = new Circle(Point, Autodesk.AutoCAD.Geometry.Vector3d.ZAxis, 10);
                    btr.AppendEntity(pointCircle);
                    trans.AddNewlyCreatedDBObject(pointCircle, true);
                  
                    ObjectIdCollection circleIds = new ObjectIdCollection();
                    circleIds.Add(pointCircle.Id);  
                    trans.Commit();

                    Hatch fillHatch = new Hatch();// 填充
                    fillHatch.SetDatabaseDefaults();

                    btr.AppendEntity(fillHatch);
                    trans.AddNewlyCreatedDBObject(fillHatch, true);
                    
                    fillHatch.Associative = true;
                    fillHatch.AppendLoop(HatchLoopTypes.Default, circleIds);
                    fillHatch.EvaluateHatch(false);                  
                                    
                } // Using         

            }// try
            catch (System.Exception e)
            {
                CadEditor.Show(e.Message);
            }
 楼主| 发表于 2007-10-22 17:45:00 | 显示全部楼层

 不好意思 ,代码修正一下, 各位高手帮帮办忙,谢谢。
  

 try
            {
                Database db = HostApplicationServices.WorkingDatabase;// 获得当前工作空间的数据库
                using(Transaction trans = db.TransactionManager.StartTransaction())// begin the transaction
                {
                    BlockTable bt = trans.GetObject(db.BlockTableId, OpenMode.ForWrite) as BlockTable;//获得块表
                    BlockTableRecord btr = bt[BlockTableRecord.ModelSpace].GetObject(OpenMode.ForWrite) as BlockTableRecord;//获得模型空间的块表记录
                    oint3d Point = Point3d(10, 200, 200);
                    Circle pointCircle = new Circle(Point, Autodesk.AutoCAD.Geometry.Vector3d.ZAxis, 10);
                    btr.AppendEntity(pointCircle);
                    trans.AddNewlyCreatedDBObject(pointCircle, true);
                  
                    ObjectIdCollection circleIds = new ObjectIdCollection();
                    circleIds.Add(pointCircle.Id);  
                    

                    Hatch fillHatch = new Hatch();// 填充
                    fillHatch.SetDatabaseDefaults();

                    btr.AppendEntity(fillHatch);
                    trans.AddNewlyCreatedDBObject(fillHatch, true);
                    
                    fillHatch.Associative = true;
                    fillHatch.AppendLoop(HatchLoopTypes.Default, circleIds);
                    fillHatch.EvaluateHatch(false);                  
                    trans.Commit();               
                } // Using         

            }// try
            catch (System.Exception e)
            {
                CadEditor.Show(e.Message);
            }

发表于 2011-5-10 18:23:20 | 显示全部楼层
加上fillHatch.SetHatchPattern(HatchPatternType.PreDefined, "ANSI35");
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 22:40 , Processed in 0.162410 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表